#include "Compiler.h"
#include <fpieee.h>
#include <excpt.h>
#include <float.h>
#include <math.h>
#include "SEH.h"

int fpieee_handler(_FPIEEE_RECORD *pieee ) {
     // user-defined ieee trap handler routine:
     // there is one handler for all 
     // IEEE exceptions
  
     // Assume the user wants all invalid 
     // operations to return 0.
  
     if ((pieee->Cause.InvalidOperation) && 
         (pieee->Result.Format == _FpFormatFp32)) 
     {
          pieee->Result.Value.Fp32Value = 0.0F;
  
          return EXCEPTION_CONTINUE_EXECUTION;
     }
     else
        return EXCEPTION_EXECUTE_HANDLER;
}
