#define NMSGSTRINGS 135
char *stringTable[NMSGSTRINGS] = {
"2232     %s cannot contain separators or special symbols.",
"2233     %s cannot begin with a number.",
"2235     Error: the name \"%s\" is already used to identify a program.",
"2236     Error: the name \"%s\" is already used to identify an array.",
"2238     %s cannot be empty.",
"2288     Identifier cannot be empty.",
"2289     Identifier cannot contain separators or special symbols.",
"2290     Identifier cannot begin with a number.",
"2292     Error: the name \"%s\" is already used to identify a system variable.",
"2293     Error: the name \"%s\" is already used to identify a built-in function.",
"2372     Error: the name \"%s\" is already used to identify a built-in array.",
"2373     Error: \"if\", \"while\" or \"for\" operator condition statement is empty.",
"2374     Error: each right brace must be the last character of a line.",
"2375     Error: \"if\", \"while\" or \"for\" operator condition statement cannot contain the assignment operator.",
"2376     Error: the expression begins with an arithmetic or logical operator symbol.",
"2377     Error: the expression begins with a parenthesis.",
"2378     Error: the expression begins with the comma.",
"2379     Error: the expression ends with an arithmetic or logical operator symbol.",
"2380     Error: the expression ends with the comma.",
"2381     Error: mismatched parentheses.",
"2382     Incorrect usage of the comma (the comma can only be used to separate function arguments or array indices).",
"2383     Incorrect usage of parentheses or of the comma.",
"2384     Error: the right parenthesis precedes the left parenthesis.",
"2385     Error: illegal character sequence before the assignment operator.",
"2386     Unknown function \"%s\".",
"2387     Incorrect usage of parentheses.",
"2388     Error: two assignment operators found in a single statement.",
"2389     Error: a variable name missing before the assignment operator.",
"2390     Error: no arithmetic operators may be used before the assignment operator.",
"2391     Error: incorrect usage of the character '!'.",
"2392     Error: missing left parenthesis after the function name \"%s\".",
"2393     Error: numerical constants cannot appear before the assignment operator.",
"2394     Error: the right parenthesis precedes a numerical constant.",
"2395     Incorrect syntax.",
"2396     Error: an illegal sequence of two binary operators, or an operator and a separator, or two separators found.",
"2398     Error: the right parenthesis precedes a function name.",
"2399     Error: the right parenthesis cannot be followed by \"%s\".",
"2400     Unknown separator '%c'.",
"2401     Unknown identifier \"%c%s\".",
"2402     Unknown identifier \"%s\".",
"2404     Runtime error: subroutine call depth (nesting level) exceeds %d. Stack overflow is possible.",
"2405     Missing operands or function arguments.",
"2406     Error: incorrect usage of keywords \"while\", \"for\" or \"if\" and \"else\".",
"2407     Incorrect syntax or missing function arguments.",
"2408     Error: uninitialized variable \"%s\" used.",
"2410     Error: variable \"%s\" is used without first initializing variable \"%s\".",
"2415     Too many operands or function arguments.",
"2416     Error: the identifier \"%s\" may not appear on the left-hand side of an assignment statement.",
"2417     Error: in this program, the identifier \"%s\" cannot appear on the left-hand side of an assignment statement.",
"2419     Warning: the result may be undefined (some \"if\", \"else\", \"while\" or \"for\" blocks are empty, or some \"else\" blocks are missing).",
"2420     Warning: variable \"%s\" may be used before its value is set (see previous \"if\", \"while\" or \"for\" operators).",
"2532     Parameter name",
"2646     Error: the right brace belonging to a higher-level \"if\", \"while\" or \"for\" operator must be on the next line.",
"2650     There are errors in program \"%s\".",
"2651     Error: mismatched parentheses or brackets.",
"2652     Error: mismatched brackets.",
"2653     Error: missing left bracket after the array name \"%s\".",
"2654     Unknown array \"%s\".",
"2655     Error: the right parenthesis precedes an array name.",
"2656     Runtime error when referencing array \"%s\"",
"2657     Runtime error in program \"%s\" referencing array \"%s\"",
"2669     Error: duplicate name \"%s\" found in the list of formal parameters.",
"2670     Warning: formal parameter \"%s\" is not used.",
"2671     Error: the program code is empty.",
"2672     Execution of the program was interrupted by the user, or an unspecified runtime error occurred.",
"2674     global parameter",
"2675     subroutine",
"2676     DLL function",
"2677     array",
"2678     Error: the name of a formal parameter coincides with the subroutine name.",
"2679     Error: the formal parameter names coincide with the names of the following global objects:",
"2698     Error: empty string after the assignment operator.",
"2704     Syntax error in specification of an address of a variable, array or function.",
"2705     Syntax error in specification of the number of array dimensions: only commas, spaces and tabs are allowed between brackets '[' and ']'.",
"2717      (index is out of bounds).",
"2718      (array is not allocated).",
"2719     local parameter",
"2722     Error: number of array dimensions is greater than 20.",
"2723     Syntax error in specification of an address of an array: missing right parenthesis after the right bracket ']'.",
"2724     Syntax error in specification of the number of array dimensions: missing right bracket ']'.",
"2725     Syntax error in specification of a function in the list of formal parameters.",
"2726     In specification of arguments of a function, which is a formal parameter of another function, each left parenthesis '(' must be preceded by the identifier \"loc\".",
"2727     Arrays that are arguments of a function, which is itself a formal parameter, can have only one or two dimensions.",
"2728     The right bracket ']' used in specification of an array that is a formal parameter of a function must be followed by the right parenthesis ')'.",
"2729     A function that is used as a formal parameter of another function cannot have more than 3 arguments.",
"2730     Error: a constant is used as an argument of function \"loc\".",
"2731     Error: the read-only variable \"%s\" is used as an argument of function \"loc\".",
"2732     Error: an expression is used as an argument of function \"loc\".",
"2736     Error: wrong argument type (subroutine \"%s\", argument No. %d).",
"2737     Error: a call to function \"%s\" has too few arguments.",
"2738     Error: a call to function \"%s\" has too many arguments.",
"2739     Error: a reference to array \"%s\" has too few indices.",
"2740     Error: a reference to array \"%s\" has too many indices.",
"2741      (an attempt to modify a read-only array).",
"2742     Runtime error when executing the built-in function \"%s\"",
"2743     Runtime error in subroutine \"%s\" when executing the built-in function \"%s\"",
"2744      (matrix elements are not 8-byte floating-point numbers).",
"2745      (matrix is not square).",
"2746     Error: wrong argument type (built-in function \"%s\", argument No. %d).",
"2747      (first argument is not an array address).",
"2750     Error: location of the built-in function \"loc\" cannot be used as an argument of another function.",
"2781     Error: the built-in array \"%s\" is read-only.",
"2782     Error: the identifier \"%s\" of a built-in array cannot appear before the assignment operator.",
"2783     The identifier \"%s\" of an array is used incorrectly.",
"2784     Error: the identifier \"%s\" of a built-in function cannot appear before the assignment operator.",
"2785     Error: \"%s\" is a function identifier (a formal parameter) and it cannot appear before the assignment operator.",
"2786     Error: the identifier \"%s\" of a program cannot appear before the assignment operator.",
"2789     Error: the system variable \"%s\" is used as an argument of function \"loc\".",
"2793     Error: the system variable \"%s\" is used as argument No. %d of function \"%s\".",
"2794     Error: a read-only variable is used as argument No. %d of function \"%s\".",
"2795     Error: a constant is used as argument No. %d of function \"%s\".",
"2796     Error: an expression is used as argument No. %d of function \"%s\".",
"2798      (last argument is equal to zero).",
"2802      (error code 1: maximum number of subdivisions has been achieved).",
"2803      (error code 2: the occurrence of roundoff error is detected).",
"2804      (error code 3: extremely bad integrand behavior).",
"2805      (error code 4: the algorithm does not converge).",
"2806      (error code 5: the integral is probably divergent).",
"2807      (error code 6: the input is invalid).",
"2808      (the specified maximum number of subintervals is too large).",
"2809      (the specified maximum number of Chebyshev moments is too large).",
"2810     Error: the first character after function name \"%s\", which is used as argument of \"loc\", is not the right parenthesis.",
"2814      (insufficient memory for work arrays).",
"2818      (floating-point exception).",
"2881      (error code 1: a value B is found such that F(B) = 0. The interval [B,C] may not satisfy the stopping criterion).",
"2882      (error code 2: |F(B)| exceeds the input values |F(B)|, |F(C)|. It is likely that B is close to a pole of f).",
"2883      (error code 3: no odd order root was found in the interval).",
"2884      (error code 4: number of function evaluations exceeds 500).",
"2892      (elements of array No. %d are not floating-point numbers).",
"2893      (elements of array No. 2 are not sorted in ascending order).",
"2902     Runtime error: number of nested calls to built-in integration, summation or iteration functions exceeds %d.",
"2905     Error: wrong argument type (function \"%s\", argument No. %d).",
"2906     Error: misplaced separator '%c'.",
"2907     Error: identifier \"%s\" contains separators or special symbols.",
"2908      (array elements are not floating-point numbers)."
};
