#pragma once
class CTrackColorsGridCtrl : public CGridCtrl
{
private:
	int currentTrackType;
public:
	afx_msg void OnShowColorDialog();
    afx_msg void OnColorSelected();
    afx_msg void OnKillFocus(CWnd *pNewWnd);
	afx_msg void OnLButtonDblClk(UINT nFlags, CPoint point);
	DECLARE_MESSAGE_MAP()
};

class CTrackColorsDlg : public CDialog
{
	DECLARE_DYNAMIC(CTrackColorsDlg)

public:
	CTrackColorsDlg(CWnd* pParent = NULL);   // standard constructor
	virtual ~CTrackColorsDlg();

	enum { IDD = IDD_TRACKCOLORS };
	CWnd *parent;
	CTrackColorsGridCtrl m_trackColorsGrid;
	CEdit m_genMin, m_genMax;
	int prevDefaultColor, prevSel;
	COLORREF prevColor;
	TRACKFILTERDATA *pTrackFilter;
	CButton *pOriginTypeCheckbox;
	BOOL cancelClick;

protected:
	int colorsRowHeight, colorsHeaderHeight;
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	BOOL CTrackColorsDlg::OnInitDialog();
	afx_msg void OnTrackColorsGridClick(NMHDR *pNotifyStruct, LRESULT* pResult);
	afx_msg void OnTrackColorsGridStartEdit(NMHDR *pNotifyStruct, LRESULT* pResult);
	afx_msg void OnTrackColorsGridEndEdit(NMHDR *pNotifyStruct, LRESULT* pResult);
	afx_msg void OnGenMinEdit();
	afx_msg void OnGenMaxEdit();

	DECLARE_MESSAGE_MAP()
};
