#pragma once
class CSystemVarsGridCtrl : public CGridCtrl
{
public:
    afx_msg void OnKillFocus(CWnd *pNewWnd);
	DECLARE_MESSAGE_MAP()
};

class CSystemVarsDlg : public CDialog
{
	DECLARE_DYNAMIC(CSystemVarsDlg)

public:
	CSystemVarsDlg(CWnd* pParent = NULL);   // standard constructor
	virtual ~CSystemVarsDlg();

	enum { IDD = IDD_SYSTEMVARS };
	CWnd *parent;
	CSystemVarsGridCtrl m_systemVarsGrid;
	int prevValue;
	double *systemVars;

protected:
	int sysVarsRowHeight, sysVarsHeaderHeight;
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	BOOL CSystemVarsDlg::OnInitDialog();
	afx_msg void OnKillFocus(CWnd *pNewWnd);
	afx_msg void OnSystemVarsGridEndEdit(NMHDR *pNotifyStruct, LRESULT* pResult);

	DECLARE_MESSAGE_MAP()
};
